> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve the results for an event store query

GET https://rest.test.zuora.com/meters/event-store-queries/{queryId}

Retrieves paginated result rows and column metadata for a previously submitted Event Store query using its `queryId`, including total row count, row-level field values, and readiness status. Query execution is asynchronous.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/mediation/event-store/get-query-results-for-event-store

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `queryId` (string, required) — ID of the query.

### Query parameters

- `pageSize` (integer, optional, default: 20) — Page size for page-based pagination of query results. Must be used together with the `page` parameter. Maximum 50.
- `page` (integer, optional, default: 1) — 1-based page index for page-based pagination of query results. Combine with `pageSize` and the `data` > `totalCount` field in the response to iterate through all matching rows.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

## Response

### 200

OK

- `success` (boolean, optional) — Indicates whether the request was successful.
- `data` (QueryResult, optional) — Contains the query result object, including the query ID, execution status flags, total row count, column metadata, and the list of rows returned by the query.

## Errors

### 400 Bad Request Error

Bad Request

- `errors` (list of ProxyBadRequestResponseErrorsItems, optional)
- `success` (boolean, optional)

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

## Types

### QueryResult

- `isFailed` (boolean, optional) — A boolean flag indicating whether the query execution has failed.
- `totalCount` (integer, optional) — The total number of rows that match the conditions defined in the executed query.
- `columns` (list of QueryResultColumnsItems, optional) — A list containing details of each column in the store.
- `rows` (list of QueryResultRowsItems, optional) — The list of rows returned by the query.
- `message` (string, optional) — Error message displayed for a failed query execution.
- `ready` (boolean, optional) — A boolean flag indicating whether the query execution has completed.

### ProxyBadRequestResponseErrorsItems

- `code` (string, optional) — Machine-readable error code identifying the failure type.
- `message` (string, optional) — Human-readable description of the error that provides more context about what went wrong.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### QueryResultColumnsItems

- `name` (string, optional) — The column name.
- `logicalType` (QueryResultColumnsItemsLogicalType, optional) — Logical type information for the column.
- `comment` (string, optional, nullable) — Optional comment or description for the column.

### QueryResultRowsItems

- `kind` (string, optional) — The kind of change for the row (for example, INSERT).
- `fields` (list of any, optional) — The ordered list of field values for this row. Each position corresponds to a column in the columns array.

### QueryResultColumnsItemsLogicalType

Logical type information for the column.

- `type` (string, optional) — The data type of the column (for example, VARCHAR, BIGINT, DECIMAL).
- `nullable` (boolean, optional) — Indicates whether the column can contain null values.
- `length` (integer, optional) — For string types, the maximum length.
- `precision` (integer, optional) — For DECIMAL types, the total number of digits.
- `scale` (integer, optional) — For DECIMAL types, the number of digits to the right of the decimal point.

## Examples

### Successful query results

**Response**

```json
{
  "success": true,
  "data": {
    "totalCount": 1,
    "columns": [
      {
        "name": "value 1",
        "logicalType": {
          "type": "VARCHAR",
          "nullable": true,
          "length": 2147483647
        },
        "comment": null
      },
      {
        "name": "value 2",
        "logicalType": {
          "type": "VARCHAR",
          "nullable": true,
          "length": 2147483647
        },
        "comment": null
      }
    ],
    "rows": [
      {
        "kind": "INSERT",
        "fields": [
          10,
          "20%"
        ]
      }
    ],
    "ready": true
  }
}
```

**SDK Code**

```python Successful query results
import requests

url = "https://rest.test.zuora.com/meters/event-store-queries/queryId"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Successful query results
const url = 'https://rest.test.zuora.com/meters/event-store-queries/queryId';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Successful query results
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/meters/event-store-queries/queryId"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Successful query results
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/meters/event-store-queries/queryId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Successful query results
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/meters/event-store-queries/queryId")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Successful query results
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/meters/event-store-queries/queryId', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Successful query results
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/meters/event-store-queries/queryId");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Successful query results
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/meters/event-store-queries/queryId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Successful paginated results (page 2 of 2)

**Response**

```json
{
  "success": true,
  "data": {
    "totalCount": 63,
    "columns": [
      {
        "name": "value 1",
        "logicalType": {
          "type": "VARCHAR",
          "nullable": true,
          "length": 2147483647
        },
        "comment": null
      },
      {
        "name": "value 2",
        "logicalType": {
          "type": "VARCHAR",
          "nullable": true,
          "length": 2147483647
        },
        "comment": null
      }
    ],
    "rows": [
      {
        "kind": "INSERT",
        "fields": [
          51,
          "some value"
        ]
      },
      {
        "kind": "INSERT",
        "fields": [
          63,
          "another value"
        ]
      }
    ],
    "ready": true
  }
}
```

**SDK Code**

```python Successful paginated results (page 2 of 2)
import requests

url = "https://rest.test.zuora.com/meters/event-store-queries/queryId"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Successful paginated results (page 2 of 2)
const url = 'https://rest.test.zuora.com/meters/event-store-queries/queryId';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Successful paginated results (page 2 of 2)
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/meters/event-store-queries/queryId"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Successful paginated results (page 2 of 2)
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/meters/event-store-queries/queryId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Successful paginated results (page 2 of 2)
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/meters/event-store-queries/queryId")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Successful paginated results (page 2 of 2)
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/meters/event-store-queries/queryId', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Successful paginated results (page 2 of 2)
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/meters/event-store-queries/queryId");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Successful paginated results (page 2 of 2)
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/meters/event-store-queries/queryId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Failed query execution

**Response**

```json
{
  "success": true,
  "data": {
    "isFailed": true,
    "message": "<error message description>",
    "ready": true
  }
}
```

**SDK Code**

```python Failed query execution
import requests

url = "https://rest.test.zuora.com/meters/event-store-queries/queryId"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Failed query execution
const url = 'https://rest.test.zuora.com/meters/event-store-queries/queryId';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Failed query execution
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/meters/event-store-queries/queryId"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Failed query execution
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/meters/event-store-queries/queryId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Failed query execution
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/meters/event-store-queries/queryId")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Failed query execution
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/meters/event-store-queries/queryId', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Failed query execution
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/meters/event-store-queries/queryId");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Failed query execution
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/meters/event-store-queries/queryId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```